/********************************************************* BTCA2A ******************************************************************

  BTCA2A -    Arduino.      BT Controller  Android.
    BTCA2A    BT Controller,   Arduino,
        Bluetooth .

    BTCA2A: v 1.0

   :   (ZSeregaA)   

   ,     http://robocontroller.ru/news/2013-11-16-40

************************************************************************************************************************************/


#include "BTCA2A.h"

btca2a::btca2a(){

}

void btca2a::SetupHardwareSerial(byte Number, long speed){
  PortNum = Number;
  switch(Number){
  case 0:
    Serial.begin(speed);
    break;
#if defined(UBRR1H)
  case 1:
    Serial1.begin(speed);
    break;
#endif
#if defined(UBRR2H)
  case 2:
    Serial2.begin(speed);
    break;
#endif
#if defined(UBRR3H)
  case 3:
    Serial3.begin(speed);
    break;
#endif
  }
}

void btca2a::SerialChoise(){
  keycode = 0;
  switch (PortNum){
  case 0:
    if (Serial.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial.read();
        BTdata[i] = BTvalue;
      }	
      keycode = BTdata[0]*100 + BTdata[1];
    }
    else 
      return;
    break;

#if defined(UBRR1H)  
  case 1:
    if (Serial1.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial1.read();
        BTdata[i] = BTvalue;
      }
      keycode = BTdata[0]*100 + BTdata[1];
    }
    else 
      return;
    break;  
#endif

#if defined(UBRR2H)  
  case 2:
    if (Serial2.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial2.read();
        BTdata[i] = BTvalue;
      }
      keycode = BTdata[0]*100 + BTdata[1];	
    }
    else 
      return;
    break;  
#endif

#if defined(UBRR3H)  
  case 3:
    if (Serial3.available()>2){
      for (i = 0; i < 3; i++){
        BTvalue = Serial3.read();
        BTdata[i] = BTvalue;
      }
      keycode = BTdata[0]*100 + BTdata[1];	
    }
    else 
      return;
    break;  
#endif  
  }
}

void btca2a::ReadCommand(){

  SerialChoise();

  if (keycode == 0)  // ,    
    return; 

  //------------------------- START CHECK COMMANDS ------------------------------------

  switch (keycode){

//------------------------- NUMBERS ---------------------------------

// -------- KEYCODE_0 ----------
  case 4855:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_0] = true;
    commandID = KEYCODE_0;
    break;

    case 85:
    buttonState[KEYCODE_0] = false;
    break;
  }
  break;

// -------- KEYCODE_1 ----------
  case 4856:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_1] = true;
    commandID = KEYCODE_1;
    break;

    case 85:
    buttonState[KEYCODE_1] = false;
    break;
  }
  break;

// -------- KEYCODE_2 ----------
  case 4857:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_2] = true;
    commandID = KEYCODE_2;
    break;

    case 85:
    buttonState[KEYCODE_2] = false;
    break;
  }
  break;

// -------- KEYCODE_3 ----------
  case 4865:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_3] = true;
    commandID = KEYCODE_3;
    break;

    case 85:
    buttonState[KEYCODE_3] = false;
    break;
  }
  break;

// -------- KEYCODE_4 ----------
  case 4866:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_4] = true;
    commandID = KEYCODE_4;
    break;

    case 85:
    buttonState[KEYCODE_4] = false;
    break;
  }
  break;

// -------- KEYCODE_5 ----------
  case 4867:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_5] = true;
    commandID = KEYCODE_5;
    break;

    case 85:
    buttonState[KEYCODE_5] = false;
    break;
  }
  break;

// -------- KEYCODE_6 ----------
  case 4868:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_6] = true;
    commandID = KEYCODE_6;
    break;

    case 85:
    buttonState[KEYCODE_6] = false;
    break;
  }
  break;

// -------- KEYCODE_7 ----------
  case 4869:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_7] = true;
    commandID = KEYCODE_7;
    break;

    case 85:
    buttonState[KEYCODE_7] = false;
    break;
  }
  break;

// -------- KEYCODE_8 ----------
  case 4870:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_8] = true;
    commandID = KEYCODE_8;
    break;

    case 85:
    buttonState[KEYCODE_8] = false;
    break;
  }
  break;

// -------- KEYCODE_9 ----------
  case 4948:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_9] = true;
    commandID = KEYCODE_9;
    break;

    case 85:
    buttonState[KEYCODE_9] = false;
    break;
  }
  break;

// ------------------------- DPAD ---------------------------------

// -------- KEYCODE_DPAD_CENTER ----------
  case 4955:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_DPAD_CENTER] = true;
    commandID = KEYCODE_DPAD_CENTER;
    break;

    case 85:
    buttonState[KEYCODE_DPAD_CENTER] = false;
    break;
  }
  break;

// -------- KEYCODE_DPAD_LEFT -----------
  case 4953:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_LEFT] = true;
      commandID = KEYCODE_DPAD_LEFT;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_LEFT] = false;
      break;
    }
    break;

// -------- KEYCODE_DPAD_UP -----------
  case 4951:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_UP] = true;
      commandID = KEYCODE_DPAD_UP;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_UP] = false;
      break;
    }
    break;

// -------- KEYCODE_DPAD_DOWN -----------
  case 4952:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_DOWN] = true;
      commandID = KEYCODE_DPAD_DOWN;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_DOWN] = false;
      break;
    }
    break;

// -------- KEYCODE_DPAD_RIGHT -----------
  case 4954:
    switch (BTdata[2]){
    case 68:
      buttonState[KEYCODE_DPAD_RIGHT] = true;
      commandID = KEYCODE_DPAD_RIGHT;
      break;

    case 85:
      buttonState[KEYCODE_DPAD_RIGHT] = false;
      break;
    }
    break;

// ------------------------- CONTROLLER ---------------------------------

// -------- KEYCODE_BUTTON_1 ----------
  case 6667:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_1] = true;
    commandID = KEYCODE_BUTTON_1;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_1] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_2 ----------
  case 6668:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_2] = true;
    commandID = KEYCODE_BUTTON_2;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_2] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_3 ----------
  case 6669:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_3] = true;
    commandID = KEYCODE_BUTTON_3;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_3] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_4 ----------
  case 6670:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_4] = true;
    commandID = KEYCODE_BUTTON_4;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_4] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_5 ----------
  case 6748:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_5] = true;
    commandID = KEYCODE_BUTTON_5;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_5] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_6 ----------
  case 6749:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_6] = true;
    commandID = KEYCODE_BUTTON_6;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_6] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_7 ----------
  case 6750:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_7] = true;
    commandID = KEYCODE_BUTTON_7;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_7] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_8 ----------
  case 6751:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_8] = true;
    commandID = KEYCODE_BUTTON_8;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_8] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_9 ----------
  case 6752:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_9] = true;
    commandID = KEYCODE_BUTTON_9;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_9] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_10 ----------
  case 6753:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_10] = true;
    commandID = KEYCODE_BUTTON_10;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_10] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_11 ----------
  case 6754:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_11] = true;
    commandID = KEYCODE_BUTTON_11;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_11] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_12 ----------
  case 6755:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_12] = true;
    commandID = KEYCODE_BUTTON_12;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_12] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_13 ----------
  case 6756:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_13] = true;
    commandID = KEYCODE_BUTTON_13;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_13] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_14 ----------
  case 6757:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_14] = true;
    commandID = KEYCODE_BUTTON_14;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_14] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_15 ----------
  case 6765:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_15] = true;
    commandID = KEYCODE_BUTTON_15;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_15] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_16 ----------
  case 6766:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_16] = true;
    commandID = KEYCODE_BUTTON_16;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_16] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_A ----------
  case 5448:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_A] = true;
    commandID = KEYCODE_BUTTON_A;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_A] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_B ----------
  case 5449:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_B] = true;
    commandID = KEYCODE_BUTTON_B;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_B] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_C ----------
  case 5450:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_C] = true;
    commandID = KEYCODE_BUTTON_C;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_C] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_X ----------
  case 5451:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_X] = true;
    commandID = KEYCODE_BUTTON_X;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_X] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_Y ----------
  case 5452:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_Y] = true;
    commandID = KEYCODE_BUTTON_Y;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_Y] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_Z ----------
  case 5453:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_Z] = true;
    commandID = KEYCODE_BUTTON_Z;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_Z] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_R1 ----------
  case 5455:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_R1] = true;
    commandID = KEYCODE_BUTTON_R1;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_R1] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_R2 ----------
  case 5457:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_R2] = true;
    commandID = KEYCODE_BUTTON_R2;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_R2] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_L1 ----------
  case 5454:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_L1] = true;
    commandID = KEYCODE_BUTTON_L1;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_L1] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_L2 ----------
  case 5456:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_L2] = true;
    commandID = KEYCODE_BUTTON_L2;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_L2] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_THUMBL ----------
  case 5465:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_THUMBL] = true;
    commandID = KEYCODE_BUTTON_THUMBL;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_THUMBL] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_THUMBR ----------
  case 5466:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_THUMBR] = true;
    commandID = KEYCODE_BUTTON_THUMBR;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_THUMBR] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_SELECT ----------
  case 5468:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_SELECT] = true;
    commandID = KEYCODE_BUTTON_SELECT;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_SELECT] = false;
    break;
  }
  break;

// -------- KEYCODE_BUTTON_START ----------
  case 5467:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BUTTON_START] = true;
    commandID = KEYCODE_BUTTON_START;
    break;

    case 85:
    buttonState[KEYCODE_BUTTON_START] = false;
    break;
  }
  break;

// ------------------------- NUMPAD ---------------------------------

// -------- KEYCODE_NUMPAD_0 ----------
  case 5748:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_0] = true;
    commandID = KEYCODE_NUMPAD_0;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_0] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_1 ----------
  case 5749:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_1] = true;
    commandID = KEYCODE_NUMPAD_1;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_1] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_2 ----------
  case 5750:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_2] = true;
    commandID = KEYCODE_NUMPAD_2;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_2] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_3 ----------
  case 5751:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_3] = true;
    commandID = KEYCODE_NUMPAD_3;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_3] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_4 ----------
  case 5752:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_4] = true;
    commandID = KEYCODE_NUMPAD_4;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_4] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_5 ----------
  case 5753:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_5] = true;
    commandID = KEYCODE_NUMPAD_5;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_5] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_6 ----------
  case 5754:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_6] = true;
    commandID = KEYCODE_NUMPAD_6;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_6] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_7 ----------
  case 5755:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_7] = true;
    commandID = KEYCODE_NUMPAD_7;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_7] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_8 ----------
  case 5756:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_8] = true;
    commandID = KEYCODE_NUMPAD_8;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_8] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_9 ----------
  case 5757:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_9] = true;
    commandID = KEYCODE_NUMPAD_9;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_9] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_LOCK ----------
  case 5670:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_LOCK] = true;
    commandID = KEYCODE_NUMPAD_LOCK;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_LOCK] = false;
    break;
  }
  break;

// -------- KEYCODE_NUM ----------
  case 5269:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUM] = true;
    commandID = KEYCODE_NUM;
    break;

    case 85:
    buttonState[KEYCODE_NUM] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_ADD ----------
  case 5768:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_ADD] = true;
    commandID = KEYCODE_NUMPAD_ADD;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_ADD] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_DIVIDE ----------
  case 5765:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_DIVIDE] = true;
    commandID = KEYCODE_NUMPAD_DIVIDE;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_DIVIDE] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_ENTER ----------
  case 6548:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_ENTER] = true;
    commandID = KEYCODE_NUMPAD_ENTER;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_ENTER] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_LEFT_PAREN ----------
  case 6550:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_LEFT_PAREN] = true;
    commandID = KEYCODE_NUMPAD_LEFT_PAREN;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_LEFT_PAREN] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_RIGHT_PAREN ----------
  case 6551:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_RIGHT_PAREN] = true;
    commandID = KEYCODE_NUMPAD_RIGHT_PAREN;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_RIGHT_PAREN] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_COMMA ----------
  case 5770:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_COMMA] = true;
    commandID = KEYCODE_NUMPAD_COMMA;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_COMMA] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_DOT ----------
  case 5769:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_DOT] = true;
    commandID = KEYCODE_NUMPAD_DOT;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_DOT] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_EQUALS ----------
  case 6549:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_EQUALS] = true;
    commandID = KEYCODE_NUMPAD_EQUALS;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_EQUALS] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_MULTIPLY ----------
  case 5766:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_MULTIPLY] = true;
    commandID = KEYCODE_NUMPAD_MULTIPLY;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_MULTIPLY] = false;
    break;
  }
  break;

// -------- KEYCODE_NUMPAD_SUBTRACT ----------
  case 5767:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NUMPAD_SUBTRACT] = true;
    commandID = KEYCODE_NUMPAD_SUBTRACT;
    break;

    case 85:
    buttonState[KEYCODE_NUMPAD_SUBTRACT] = false;
    break;
  }
  break;



// ------------------------- LETTERS ---------------------------------

// -------- KEYCODE_A ----------
  case 4968:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_A] = true;
    commandID = KEYCODE_A;
    break;

    case 85:
    buttonState[KEYCODE_A] = false;
    break;
  }
  break;

// -------- KEYCODE_B ----------
  case 4969:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_B] = true;
    commandID = KEYCODE_B;
    break;

    case 85:
    buttonState[KEYCODE_B] = false;
    break;
  }
  break;

// -------- KEYCODE_C ----------
  case 4970:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_C] = true;
    commandID = KEYCODE_C;
    break;

    case 85:
    buttonState[KEYCODE_C] = false;
    break;
  }
  break;

// -------- KEYCODE_D ----------
  case 5048:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_D] = true;
    commandID = KEYCODE_D;
    break;

    case 85:
    buttonState[KEYCODE_D] = false;
    break;
  }
  break;

// -------- KEYCODE_E ----------
  case 5049:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_E] = true;
    commandID = KEYCODE_E;
    break;

    case 85:
    buttonState[KEYCODE_E] = false;
    break;
  }
  break;

// -------- KEYCODE_F ----------
  case 5050:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F] = true;
    commandID = KEYCODE_F;
    break;

    case 85:
    buttonState[KEYCODE_F] = false;
    break;
  }
  break;

// -------- KEYCODE_G ----------
  case 5051:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_G] = true;
    commandID = KEYCODE_G;
    break;

    case 85:
    buttonState[KEYCODE_G] = false;
    break;
  }
  break;

// -------- KEYCODE_H ----------
  case 5052:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_H] = true;
    commandID = KEYCODE_H;
    break;

    case 85:
    buttonState[KEYCODE_H] = false;
    break;
  }
  break;

// -------- KEYCODE_I ----------
  case 5053:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_I] = true;
    commandID = KEYCODE_I;
    break;

    case 85:
    buttonState[KEYCODE_I] = false;
    break;
  }
  break;

// -------- KEYCODE_J ----------
  case 5054:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_J] = true;
    commandID = KEYCODE_J;
    break;

    case 85:
    buttonState[KEYCODE_J] = false;
    break;
  }
  break;

// -------- KEYCODE_K ----------
  case 5055:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_K] = true;
    commandID = KEYCODE_K;
    break;

    case 85:
    buttonState[KEYCODE_K] = false;
    break;
  }
  break;

// -------- KEYCODE_L ----------
  case 5056:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_L] = true;
    commandID = KEYCODE_L;
    break;

    case 85:
    buttonState[KEYCODE_L] = false;
    break;
  }
  break;

// -------- KEYCODE_M ----------
  case 5057:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_M] = true;
    commandID = KEYCODE_M;
    break;

    case 85:
    buttonState[KEYCODE_M] = false;
    break;
  }
  break;

// -------- KEYCODE_N ----------
  case 5065:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_N] = true;
    commandID = KEYCODE_N;
    break;

    case 85:
    buttonState[KEYCODE_N] = false;
    break;
  }
  break;

// -------- KEYCODE_O ----------
  case 5066:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_O] = true;
    commandID = KEYCODE_O;
    break;

    case 85:
    buttonState[KEYCODE_O] = false;
    break;
  }
  break;

// -------- KEYCODE_P ----------
  case 5067:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_P] = true;
    commandID = KEYCODE_P;
    break;

    case 85:
    buttonState[KEYCODE_P] = false;
    break;
  }
  break;

// -------- KEYCODE_Q ----------
  case 5068:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_Q] = true;
    commandID = KEYCODE_Q;
    break;

    case 85:
    buttonState[KEYCODE_Q] = false;
    break;
  }
  break;

// -------- KEYCODE_R ----------
  case 5069:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_R] = true;
    commandID = KEYCODE_R;
    break;

    case 85:
    buttonState[KEYCODE_R] = false;
    break;
  }
  break;

// -------- KEYCODE_S ----------
  case 5070:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_S] = true;
    commandID = KEYCODE_S;
    break;

    case 85:
    buttonState[KEYCODE_S] = false;
    break;
  }
  break;

// -------- KEYCODE_T ----------
  case 5148:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_T] = true;
    commandID = KEYCODE_T;
    break;

    case 85:
    buttonState[KEYCODE_T] = false;
    break;
  }
  break;

// -------- KEYCODE_U ----------
  case 5149:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_U] = true;
    commandID = KEYCODE_U;
    break;

    case 85:
    buttonState[KEYCODE_U] = false;
    break;
  }
  break;

// -------- KEYCODE_V ----------
  case 5150:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_V] = true;
    commandID = KEYCODE_V;
    break;

    case 85:
    buttonState[KEYCODE_V] = false;
    break;
  }
  break;

// -------- KEYCODE_W ----------
  case 5151:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_W] = true;
    commandID = KEYCODE_W;
    break;

    case 85:
    buttonState[KEYCODE_W] = false;
    break;
  }
  break;

// -------- KEYCODE_X ----------
  case 5152:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_X] = true;
    commandID = KEYCODE_X;
    break;

    case 85:
    buttonState[KEYCODE_X] = false;
    break;
  }
  break;

// -------- KEYCODE_Y ----------
  case 5153:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_Y] = true;
    commandID = KEYCODE_Y;
    break;

    case 85:
    buttonState[KEYCODE_Y] = false;
    break;
  }
  break;

// -------- KEYCODE_Z ----------
  case 5154:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_Z] = true;
    commandID = KEYCODE_Z;
    break;

    case 85:
    buttonState[KEYCODE_Z] = false;
    break;
  }
  break;


// ------------------------- SYMBOLS ---------------------------------

// -------- KEYCODE_APOSTROPHE ----------
  case 5266:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_APOSTROPHE] = true;
    commandID = KEYCODE_APOSTROPHE;
    break;

    case 85:
    buttonState[KEYCODE_APOSTROPHE] = false;
    break;
  }
  break;

// -------- KEYCODE_BACKSLASH ----------
  case 5257:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BACKSLASH] = true;
    commandID = KEYCODE_BACKSLASH;
    break;

    case 85:
    buttonState[KEYCODE_BACKSLASH] = false;
    break;
  }
  break;

// -------- KEYCODE_DEL ----------
  case 5251:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_DEL] = true;
    commandID = KEYCODE_DEL;
    break;

    case 85:
    buttonState[KEYCODE_DEL] = false;
    break;
  }
  break;

// -------- KEYCODE_ESCAPE ----------
  case 5470:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ESCAPE] = true;
    commandID = KEYCODE_ESCAPE;
    break;

    case 85:
    buttonState[KEYCODE_ESCAPE] = false;
    break;
  }
  break;

// -------- KEYCODE_LEFT_BRACKET ----------
  case 5255:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_LEFT_BRACKET] = true;
    commandID = KEYCODE_LEFT_BRACKET;
    break;

    case 85:
    buttonState[KEYCODE_LEFT_BRACKET] = false;
    break;
  }
  break;

// -------- KEYCODE_PLUS ----------
  case 5349:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PLUS] = true;
    commandID = KEYCODE_PLUS;
    break;

    case 85:
    buttonState[KEYCODE_PLUS] = false;
    break;
  }
  break;

// -------- KEYCODE_RIGHT_BRACKET ----------
  case 5256:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_RIGHT_BRACKET] = true;
    commandID = KEYCODE_RIGHT_BRACKET;
    break;

    case 85:
    buttonState[KEYCODE_RIGHT_BRACKET] = false;
    break;
  }
  break;

// -------- KEYCODE_SLASH ----------
  case 5267:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SLASH] = true;
    commandID = KEYCODE_SLASH;
    break;

    case 85:
    buttonState[KEYCODE_SLASH] = false;
    break;
  }
  break;

// -------- KEYCODE_STAR ----------
  case 4949:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_STAR] = true;
    commandID = KEYCODE_STAR;
    break;

    case 85:
    buttonState[KEYCODE_STAR] = false;
    break;
  }
  break;

// -------- KEYCODE_AT ----------
  case 5268:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_AT] = true;
    commandID = KEYCODE_AT;
    break;

    case 85:
    buttonState[KEYCODE_AT] = false;
    break;
  }
  break;

// -------- KEYCODE_COMMA ----------
  case 5155:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_COMMA] = true;
    commandID = KEYCODE_COMMA;
    break;

    case 85:
    buttonState[KEYCODE_COMMA] = false;
    break;
  }
  break;

// -------- KEYCODE_EQUALS ----------
  case 5254:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_EQUALS] = true;
    commandID = KEYCODE_EQUALS;
    break;

    case 85:
    buttonState[KEYCODE_EQUALS] = false;
    break;
  }
  break;

// -------- KEYCODE_FORWARD_DEL ----------
  case 5548:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_FORWARD_DEL] = true;
    commandID = KEYCODE_FORWARD_DEL;
    break;

    case 85:
    buttonState[KEYCODE_FORWARD_DEL] = false;
    break;
  }
  break;

// -------- KEYCODE_PERIOD ----------
  case 5156:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PERIOD] = true;
    commandID = KEYCODE_PERIOD;
    break;

    case 85:
    buttonState[KEYCODE_PERIOD] = false;
    break;
  }
  break;

// -------- KEYCODE_POUND ----------
  case 4950:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_POUND] = true;
    commandID = KEYCODE_POUND;
    break;

    case 85:
    buttonState[KEYCODE_POUND] = false;
    break;
  }
  break;

// -------- KEYCODE_SEMICOLON ----------
  case 5265:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SEMICOLON] = true;
    commandID = KEYCODE_SEMICOLON;
    break;

    case 85:
    buttonState[KEYCODE_SEMICOLON] = false;
    break;
  }
  break;

// -------- KEYCODE_SPACE ----------
  case 5169:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SPACE] = true;
    commandID = KEYCODE_SPACE;
    break;

    case 85:
    buttonState[KEYCODE_SPACE] = false;
    break;
  }
  break;

// -------- KEYCODE_TAB ----------
  case 5168:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_TAB] = true;
    commandID = KEYCODE_TAB;
    break;

    case 85:
    buttonState[KEYCODE_TAB] = false;
    break;
  }
  break;


// ------------------------- OTHER ---------------------------------

// -------- KEYCODE_ALT_LEFT ----------
  case 5157:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ALT_LEFT] = true;
    commandID = KEYCODE_ALT_LEFT;
    break;

    case 85:
    buttonState[KEYCODE_ALT_LEFT] = false;
    break;
  }
  break;

// -------- KEYCODE_ALT_RIGHT ----------
  case 5165:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ALT_RIGHT] = true;
    commandID = KEYCODE_ALT_RIGHT;
    break;

    case 85:
    buttonState[KEYCODE_ALT_RIGHT] = false;
    break;
  }
  break;

// -------- KEYCODE_BREAK ----------
  case 5557:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BREAK] = true;
    commandID = KEYCODE_BREAK;
    break;

    case 85:
    buttonState[KEYCODE_BREAK] = false;
    break;
  }
  break;

// -------- KEYCODE_CLEAR ----------
  case 4967:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CLEAR] = true;
    commandID = KEYCODE_CLEAR;
    break;

    case 85:
    buttonState[KEYCODE_CLEAR] = false;
    break;
  }
  break;

// -------- KEYCODE_CTRL_LEFT ----------
  case 5549:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CTRL_LEFT] = true;
    commandID = KEYCODE_CTRL_LEFT;
    break;

    case 85:
    buttonState[KEYCODE_CTRL_LEFT] = false;
    break;
  }
  break;

// -------- KEYCODE_CTRL_RIGHT ----------
  case 5550:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CTRL_RIGHT] = true;
    commandID = KEYCODE_CTRL_RIGHT;
    break;

    case 85:
    buttonState[KEYCODE_CTRL_RIGHT] = false;
    break;
  }
  break;

// -------- KEYCODE_ENTER ----------
  case 5250:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ENTER] = true;
    commandID = KEYCODE_ENTER;
    break;

    case 85:
    buttonState[KEYCODE_ENTER] = false;
    break;
  }
  break;

// -------- KEYCODE_FORVARD ----------
  case 5568:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_FORVARD] = true;
    commandID = KEYCODE_FORVARD;
    break;

    case 85:
    buttonState[KEYCODE_FORVARD] = false;
    break;
  }
  break;

// -------- KEYCODE_PAGE_DOWN ----------
  case 5368:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PAGE_DOWN] = true;
    commandID = KEYCODE_PAGE_DOWN;
    break;

    case 85:
    buttonState[KEYCODE_PAGE_DOWN] = false;
    break;
  }
  break;

// -------- KEYCODE_PAGE_UP ----------
  case 5367:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PAGE_UP] = true;
    commandID = KEYCODE_PAGE_UP;
    break;

    case 85:
    buttonState[KEYCODE_PAGE_UP] = false;
    break;
  }
  break;

// -------- KEYCODE_SHIFT_LEFT ----------
  case 5166:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SHIFT_LEFT] = true;
    commandID = KEYCODE_SHIFT_LEFT;
    break;

    case 85:
    buttonState[KEYCODE_SHIFT_LEFT] = false;
    break;
  }
  break;

// -------- KEYCODE_SHIFT_RIGHT ----------
  case 5167:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SHIFT_RIGHT] = true;
    commandID = KEYCODE_SHIFT_RIGHT;
    break;

    case 85:
    buttonState[KEYCODE_SHIFT_RIGHT] = false;
    break;
  }
  break;

// -------- KEYCODE_SOFT_LEFT ----------
  case 4849:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SOFT_LEFT] = true;
    commandID = KEYCODE_SOFT_LEFT;
    break;

    case 85:
    buttonState[KEYCODE_SOFT_LEFT] = false;
    break;
  }
  break;

// -------- KEYCODE_SOFT_RIGHT ----------
  case 4850:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SOFT_RIGHT] = true;
    commandID = KEYCODE_SOFT_RIGHT;
    break;

    case 85:
    buttonState[KEYCODE_SOFT_RIGHT] = false;
    break;
  }
  break;


// ------------------------- SYSTEM ---------------------------------

// -------- KEYCODE_3D_MODE ----------
  case 6769:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_3D_MODE] = true;
    commandID = KEYCODE_3D_MODE;
    break;

    case 85:
    buttonState[KEYCODE_3D_MODE] = false;
    break;
  }
  break;

// -------- KEYCODE_AVR_INPUT ----------
  case 6654:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_AVR_INPUT] = true;
    commandID = KEYCODE_AVR_INPUT;
    break;

    case 85:
    buttonState[KEYCODE_AVR_INPUT] = false;
    break;
  }
  break;

// -------- KEYCODE_BACK ----------
  case 4852:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BACK] = true;
    commandID = KEYCODE_BACK;
    break;

    case 85:
    buttonState[KEYCODE_BACK] = false;
    break;
  }
  break;

// -------- KEYCODE_CALCULATOR ----------
  case 6850:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CALCULATOR] = true;
    commandID = KEYCODE_CALCULATOR;
    break;

    case 85:
    buttonState[KEYCODE_CALCULATOR] = false;
    break;
  }
  break;

// -------- KEYCODE_CALL ----------
  case 4853:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CALL] = true;
    commandID = KEYCODE_CALL;
    break;

    case 85:
    buttonState[KEYCODE_CALL] = false;
    break;
  }
  break;

// -------- KEYCODE_CAPS_LOCK ----------
  case 5551:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CAPS_LOCK] = true;
    commandID = KEYCODE_CAPS_LOCK;
    break;

    case 85:
    buttonState[KEYCODE_CAPS_LOCK] = false;
    break;
  }
  break;

// -------- KEYCODE_CHANNEL_DOWN ----------
  case 6555:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CHANNEL_DOWN] = true;
    commandID = KEYCODE_CHANNEL_DOWN;
    break;

    case 85:
    buttonState[KEYCODE_CHANNEL_DOWN] = false;
    break;
  }
  break;

// -------- KEYCODE_CONTACTS ----------
  case 6770:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CONTACTS] = true;
    commandID = KEYCODE_CONTACTS;
    break;

    case 85:
    buttonState[KEYCODE_CONTACTS] = false;
    break;
  }
  break;

// -------- KEYCODE_ENDCALL ----------
  case 4854:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ENDCALL] = true;
    commandID = KEYCODE_ENDCALL;
    break;

    case 85:
    buttonState[KEYCODE_ENDCALL] = false;
    break;
  }
  break;

// -------- KEYCODE_EXPLORER ----------
  case 5248:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_EXPLORER] = true;
    commandID = KEYCODE_EXPLORER;
    break;

    case 85:
    buttonState[KEYCODE_EXPLORER] = false;
    break;
  }
  break;

// -------- KEYCODE_F10 ----------
  case 5667:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F10] = true;
    commandID = KEYCODE_F10;
    break;

    case 85:
    buttonState[KEYCODE_F10] = false;
    break;
  }
  break;

// -------- KEYCODE_F12 ----------
  case 5669:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F12] = true;
    commandID = KEYCODE_F12;
    break;

    case 85:
    buttonState[KEYCODE_F12] = false;
    break;
  }
  break;

// -------- KEYCODE_F3 ----------
  case 5653:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F3] = true;
    commandID = KEYCODE_F3;
    break;

    case 85:
    buttonState[KEYCODE_F3] = false;
    break;
  }
  break;

// -------- KEYCODE_F5 ----------
  case 5655:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F5] = true;
    commandID = KEYCODE_F5;
    break;

    case 85:
    buttonState[KEYCODE_F5] = false;
    break;
  }
  break;

// -------- KEYCODE_F7 ----------
  case 5657:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F7] = true;
    commandID = KEYCODE_F7;
    break;

    case 85:
    buttonState[KEYCODE_F7] = false;
    break;
  }
  break;

// -------- KEYCODE_F9 ----------
  case 5666:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F9] = true;
    commandID = KEYCODE_F9;
    break;

    case 85:
    buttonState[KEYCODE_F9] = false;
    break;
  }
  break;

// -------- KEYCODE_FUNCTION ----------
  case 5555:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_FUNCTION] = true;
    commandID = KEYCODE_FUNCTION;
    break;

    case 85:
    buttonState[KEYCODE_FUNCTION] = false;
    break;
  }
  break;

// -------- KEYCODE_GUIDE ----------
  case 6567:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_GUIDE] = true;
    commandID = KEYCODE_GUIDE;
    break;

    case 85:
    buttonState[KEYCODE_GUIDE] = false;
    break;
  }
  break;

// -------- KEYCODE_HOME ----------
  case 4851:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_HOME] = true;
    commandID = KEYCODE_HOME;
    break;

    case 85:
    buttonState[KEYCODE_HOME] = false;
    break;
  }
  break;

// -------- KEYCODE_INSERT ----------
  case 5567:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_INSERT] = true;
    commandID = KEYCODE_INSERT;
    break;

    case 85:
    buttonState[KEYCODE_INSERT] = false;
    break;
  }
  break;

// -------- KEYCODE_MANNER_MODE ----------
  case 6768:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MANNER_MODE] = true;
    commandID = KEYCODE_MANNER_MODE;
    break;

    case 85:
    buttonState[KEYCODE_MANNER_MODE] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_EJECT ----------
  case 5649:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_EJECT] = true;
    commandID = KEYCODE_MEDIA_EJECT;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_EJECT] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_NEXT ----------
  case 5355:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_NEXT] = true;
    commandID = KEYCODE_MEDIA_NEXT;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_NEXT] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_PLAY_PAUSE ----------
  case 5353:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_PLAY_PAUSE] = true;
    commandID = KEYCODE_MEDIA_PLAY_PAUSE;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_PLAY_PAUSE] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_PREVIOUS ----------
  case 5356:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_PREVIOUS] = true;
    commandID = KEYCODE_MEDIA_PREVIOUS;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_PREVIOUS] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_REWIND ----------
  case 5357:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_REWIND] = true;
    commandID = KEYCODE_MEDIA_REWIND;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_REWIND] = false;
    break;
  }
  break;

// -------- KEYCODE_MENU ----------
  case 5350:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MENU] = true;
    commandID = KEYCODE_MENU;
    break;

    case 85:
    buttonState[KEYCODE_MENU] = false;
    break;
  }
  break;

// -------- KEYCODE_META_RIGHT ----------
  case 5554:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_META_RIGHT] = true;
    commandID = KEYCODE_META_RIGHT;
    break;

    case 85:
    buttonState[KEYCODE_META_RIGHT] = false;
    break;
  }
  break;

// -------- KEYCODE_MOVE_END ----------
  case 5566:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MOVE_END] = true;
    commandID = KEYCODE_MOVE_END;
    break;

    case 85:
    buttonState[KEYCODE_MOVE_END] = false;
    break;
  }
  break;

// -------- KEYCODE_MUSIC ----------
  case 6849:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MUSIC] = true;
    commandID = KEYCODE_MUSIC;
    break;

    case 85:
    buttonState[KEYCODE_MUSIC] = false;
    break;
  }
  break;

// -------- KEYCODE_NOTIFICATION ----------
  case 5351:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_NOTIFICATION] = true;
    commandID = KEYCODE_NOTIFICATION;
    break;

    case 85:
    buttonState[KEYCODE_NOTIFICATION] = false;
    break;
  }
  break;

// -------- KEYCODE_POWER ----------
  case 4965:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_POWER] = true;
    commandID = KEYCODE_POWER;
    break;

    case 85:
    buttonState[KEYCODE_POWER] = false;
    break;
  }
  break;

// -------- KEYCODE_PROG_GREEN ----------
  case 6656:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PROG_GREEN] = true;
    commandID = KEYCODE_PROG_GREEN;
    break;

    case 85:
    buttonState[KEYCODE_PROG_GREEN] = false;
    break;
  }
  break;

// -------- KEYCODE_PROG_YELLOW ----------
  case 6657:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PROG_YELLOW] = true;
    commandID = KEYCODE_PROG_YELLOW;
    break;

    case 85:
    buttonState[KEYCODE_PROG_YELLOW] = false;
    break;
  }
  break;

// -------- KEYCODE_SEARCH ----------
  case 5352:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SEARCH] = true;
    commandID = KEYCODE_SEARCH;
    break;

    case 85:
    buttonState[KEYCODE_SEARCH] = false;
    break;
  }
  break;

// -------- KEYCODE_STB_INPUT ----------
  case 6652:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_STB_INPUT] = true;
    commandID = KEYCODE_STB_INPUT;
    break;

    case 85:
    buttonState[KEYCODE_STB_INPUT] = false;
    break;
  }
  break;

// -------- KEYCODE_SWITCH_CHARSET ----------
  case 5370:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SWITCH_CHARSET] = true;
    commandID = KEYCODE_SWITCH_CHARSET;
    break;

    case 85:
    buttonState[KEYCODE_SWITCH_CHARSET] = false;
    break;
  }
  break;

// -------- KEYCODE_SYSRQ ----------
  case 5556:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SYSRQ] = true;
    commandID = KEYCODE_SYSRQ;
    break;

    case 85:
    buttonState[KEYCODE_SYSRQ] = false;
    break;
  }
  break;

// -------- KEYCODE_TV_POWER ----------
  case 6649:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_TV_POWER] = true;
    commandID = KEYCODE_TV_POWER;
    break;

    case 85:
    buttonState[KEYCODE_TV_POWER] = false;
    break;
  }
  break;

// -------- KEYCODE_VOLUME_MUTE ----------
  case 6552:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_VOLUME_MUTE] = true;
    commandID = KEYCODE_VOLUME_MUTE;
    break;

    case 85:
    buttonState[KEYCODE_VOLUME_MUTE] = false;
    break;
  }
  break;

// -------- KEYCODE_WINDOW ----------
  case 6566:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_WINDOW] = true;
    commandID = KEYCODE_WINDOW;
    break;

    case 85:
    buttonState[KEYCODE_WINDOW] = false;
    break;
  }
  break;

// -------- KEYCODE_ZOOM_OUT ----------
  case 6557:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ZOOM_OUT] = true;
    commandID = KEYCODE_ZOOM_OUT;
    break;

    case 85:
    buttonState[KEYCODE_ZOOM_OUT] = false;
    break;
  }
  break;

// -------- KEYCODE_APP_SWITCH ----------
  case 6666:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_APP_SWITCH] = true;
    commandID = KEYCODE_APP_SWITCH;
    break;

    case 85:
    buttonState[KEYCODE_APP_SWITCH] = false;
    break;
  }
  break;

// -------- KEYCODE_AVR_POWER ----------
  case 6653:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_AVR_POWER] = true;
    commandID = KEYCODE_AVR_POWER;
    break;

    case 85:
    buttonState[KEYCODE_AVR_POWER] = false;
    break;
  }
  break;

// -------- KEYCODE_BOOKMARK ----------
  case 6569:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_BOOKMARK] = true;
    commandID = KEYCODE_BOOKMARK;
    break;

    case 85:
    buttonState[KEYCODE_BOOKMARK] = false;
    break;
  }
  break;

// -------- KEYCODE_CALENDAR ----------
  case 6848:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CALENDAR] = true;
    commandID = KEYCODE_CALENDAR;
    break;

    case 85:
    buttonState[KEYCODE_CALENDAR] = false;
    break;
  }
  break;

// -------- KEYCODE_CAMERA ----------
  case 4966:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CAMERA] = true;
    commandID = KEYCODE_CAMERA;
    break;

    case 85:
    buttonState[KEYCODE_CAMERA] = false;
    break;
  }
  break;

// -------- KEYCODE_CAPTIONS ----------
  case 6570:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CAPTIONS] = true;
    commandID = KEYCODE_CAPTIONS;
    break;

    case 85:
    buttonState[KEYCODE_CAPTIONS] = false;
    break;
  }
  break;

// -------- KEYCODE_CHANNEL_UP ----------
  case 6554:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_CHANNEL_UP] = true;
    commandID = KEYCODE_CHANNEL_UP;
    break;

    case 85:
    buttonState[KEYCODE_CHANNEL_UP] = false;
    break;
  }
  break;

// -------- KEYCODE_DVR ----------
  case 6568:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_DVR] = true;
    commandID = KEYCODE_DVR;
    break;

    case 85:
    buttonState[KEYCODE_DVR] = false;
    break;
  }
  break;

// -------- KEYCODE_ENVELOPE ----------
  case 5249:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ENVELOPE] = true;
    commandID = KEYCODE_ENVELOPE;
    break;

    case 85:
    buttonState[KEYCODE_ENVELOPE] = false;
    break;
  }
  break;

// -------- KEYCODE_F1 ----------
  case 5651:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F1] = true;
    commandID = KEYCODE_F1;
    break;

    case 85:
    buttonState[KEYCODE_F1] = false;
    break;
  }
  break;

// -------- KEYCODE_F11 ----------
  case 5668:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F11] = true;
    commandID = KEYCODE_F11;
    break;

    case 85:
    buttonState[KEYCODE_F11] = false;
    break;
  }
  break;

// -------- KEYCODE_F2 ----------
  case 5652:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F2] = true;
    commandID = KEYCODE_F2;
    break;

    case 85:
    buttonState[KEYCODE_F2] = false;
    break;
  }
  break;

// -------- KEYCODE_F4 ----------
  case 5654:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F4] = true;
    commandID = KEYCODE_F4;
    break;

    case 85:
    buttonState[KEYCODE_F4] = false;
    break;
  }
  break;

// -------- KEYCODE_F6 ----------
  case 5656:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F6] = true;
    commandID = KEYCODE_F6;
    break;

    case 85:
    buttonState[KEYCODE_F6] = false;
    break;
  }
  break;

// -------- KEYCODE_F8 ----------
  case 5665:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_F8] = true;
    commandID = KEYCODE_F8;
    break;

    case 85:
    buttonState[KEYCODE_F8] = false;
    break;
  }
  break;

// -------- KEYCODE_FOCUS ----------
  case 5348:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_FOCUS] = true;
    commandID = KEYCODE_FOCUS;
    break;

    case 85:
    buttonState[KEYCODE_FOCUS] = false;
    break;
  }
  break;

// -------- KEYCODE_GRAVE ----------
  case 5252:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_GRAVE] = true;
    commandID = KEYCODE_GRAVE;
    break;

    case 85:
    buttonState[KEYCODE_GRAVE] = false;
    break;
  }
  break;

// -------- KEYCODE_HEADSETHOOK ----------
  case 5270:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_HEADSETHOOK] = true;
    commandID = KEYCODE_HEADSETHOOK;
    break;

    case 85:
    buttonState[KEYCODE_HEADSETHOOK] = false;
    break;
  }
  break;

// -------- KEYCODE_INFO ----------
  case 6553:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_INFO] = true;
    commandID = KEYCODE_INFO;
    break;

    case 85:
    buttonState[KEYCODE_INFO] = false;
    break;
  }
  break;

// -------- KEYCODE_LANGUAGE_SWITCH ----------
  case 6767:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_LANGUAGE_SWITCH] = true;
    commandID = KEYCODE_LANGUAGE_SWITCH;
    break;

    case 85:
    buttonState[KEYCODE_LANGUAGE_SWITCH] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_CLOSE ----------
  case 5648:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_CLOSE] = true;
    commandID = KEYCODE_MEDIA_CLOSE;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_CLOSE] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_FAST_FORWARD ----------
  case 5365:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_FAST_FORWARD] = true;
    commandID = KEYCODE_MEDIA_FAST_FORWARD;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_FAST_FORWARD] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_PAUSE ----------
  case 5570:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_PAUSE] = true;
    commandID = KEYCODE_MEDIA_PAUSE;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_PAUSE] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_PLAY ----------
  case 5569:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_PLAY] = true;
    commandID = KEYCODE_MEDIA_PLAY;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_PLAY] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_RECORD ----------
  case 5650:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_RECORD] = true;
    commandID = KEYCODE_MEDIA_RECORD;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_RECORD] = false;
    break;
  }
  break;

// -------- KEYCODE_MEDIA_STOP ----------
  case 5354:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MEDIA_STOP] = true;
    commandID = KEYCODE_MEDIA_STOP;
    break;

    case 85:
    buttonState[KEYCODE_MEDIA_STOP] = false;
    break;
  }
  break;

// -------- KEYCODE_META_LEFT ----------
  case 5553:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_META_LEFT] = true;
    commandID = KEYCODE_META_LEFT;
    break;

    case 85:
    buttonState[KEYCODE_META_LEFT] = false;
    break;
  }
  break;

// -------- KEYCODE_MINUS ----------
  case 5253:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MINUS] = true;
    commandID = KEYCODE_MINUS;
    break;

    case 85:
    buttonState[KEYCODE_MINUS] = false;
    break;
  }
  break;

// -------- KEYCODE_MOVE_HOME ----------
  case 5565:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MOVE_HOME] = true;
    commandID = KEYCODE_MOVE_HOME;
    break;

    case 85:
    buttonState[KEYCODE_MOVE_HOME] = false;
    break;
  }
  break;

// -------- KEYCODE_MUTE ----------
  case 5366:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_MUTE] = true;
    commandID = KEYCODE_MUTE;
    break;

    case 85:
    buttonState[KEYCODE_MUTE] = false;
    break;
  }
  break;

// -------- KEYCODE_PICTSYMBOLS ----------
  case 5369:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PICTSYMBOLS] = true;
    commandID = KEYCODE_PICTSYMBOLS;
    break;

    case 85:
    buttonState[KEYCODE_PICTSYMBOLS] = false;
    break;
  }
  break;

// -------- KEYCODE_PROG_BLUE ----------
  case 6665:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PROG_BLUE] = true;
    commandID = KEYCODE_PROG_BLUE;
    break;

    case 85:
    buttonState[KEYCODE_PROG_BLUE] = false;
    break;
  }
  break;

// -------- KEYCODE_PROG_RED ----------
  case 6655:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_PROG_RED] = true;
    commandID = KEYCODE_PROG_RED;
    break;

    case 85:
    buttonState[KEYCODE_PROG_RED] = false;
    break;
  }
  break;

// -------- KEYCODE_SCROLL_LOCK ----------
  case 5552:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SCROLL_LOCK] = true;
    commandID = KEYCODE_SCROLL_LOCK;
    break;

    case 85:
    buttonState[KEYCODE_SCROLL_LOCK] = false;
    break;
  }
  break;

// -------- KEYCODE_SETTINGS ----------
  case 6648:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SETTINGS] = true;
    commandID = KEYCODE_SETTINGS;
    break;

    case 85:
    buttonState[KEYCODE_SETTINGS] = false;
    break;
  }
  break;

// -------- KEYCODE_STB_POWER ----------
  case 6651:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_STB_POWER] = true;
    commandID = KEYCODE_STB_POWER;
    break;

    case 85:
    buttonState[KEYCODE_STB_POWER] = false;
    break;
  }
  break;

// -------- KEYCODE_SYM ----------
  case 5170:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_SYM] = true;
    commandID = KEYCODE_SYM;
    break;

    case 85:
    buttonState[KEYCODE_SYM] = false;
    break;
  }
  break;

// -------- KEYCODE_TV_INPUT ----------
  case 6650:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_TV_INPUT] = true;
    commandID = KEYCODE_TV_INPUT;
    break;

    case 85:
    buttonState[KEYCODE_TV_INPUT] = false;
    break;
  }
  break;

// -------- KEYCODE_TV ----------
  case 6565:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_TV] = true;
    commandID = KEYCODE_TV;
    break;

    case 85:
    buttonState[KEYCODE_TV] = false;
    break;
  }
  break;

// -------- KEYCODE_VOLUME_DOWN ----------
  case 4957:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_VOLUME_DOWN] = true;
    commandID = KEYCODE_VOLUME_DOWN;
    break;

    case 85:
    buttonState[KEYCODE_VOLUME_DOWN] = false;
    break;
  }
  break;

// -------- KEYCODE_VOLUME_UP ----------
  case 4956:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_VOLUME_UP] = true;
    commandID = KEYCODE_VOLUME_UP;
    break;

    case 85:
    buttonState[KEYCODE_VOLUME_UP] = false;
    break;
  }
  break;

// -------- KEYCODE_ZOOM_IN ----------
  case 6556:
  switch (BTdata[2]){
    case 68:
    buttonState[KEYCODE_ZOOM_IN] = true;
    commandID = KEYCODE_ZOOM_IN;
    break;

    case 85:
    buttonState[KEYCODE_ZOOM_IN] = false;
    break;
  }
  break;



  }

}

boolean btca2a::Button(unsigned char buttonID) {
  boolean results = false;

  if (buttonID == commandID){
    commandID = 0;
    results = true;
  }

  return results;
}

boolean btca2a::ButtonPressed(unsigned char buttonID) {
  boolean results = false;
  results = buttonState[buttonID];
  return results;
}

boolean btca2a::ButtonReleased(unsigned char buttonID) {
  boolean results = false;
  if(!buttonState[buttonID]){
    results = true;
  }
  return results;
}