/********************************************************* BTCA2A ******************************************************************

  BTCA2A -    Arduino.      BT Controller  Android.
    BTCA2A    BT Controller,   Arduino,
        Bluetooth .

    BTCA2A: v 1.0

   :   (ZSeregaA)   

   ,     http://robocontroller.ru/news/2013-11-16-40

************************************************************************************************************************************/

#ifndef BTCA2A_H
#define BTCA2A_H

#include <Arduino.h>

//----------- BTController buttons ID -----------

// NUMBERS
#define KEYCODE_0 2
#define KEYCODE_1 3
#define KEYCODE_2 4
#define KEYCODE_3 5
#define KEYCODE_4 6
#define KEYCODE_5 7
#define KEYCODE_6 8
#define KEYCODE_7 9
#define KEYCODE_8 10
#define KEYCODE_9 11

// DPAD
#define KEYCODE_DPAD_CENTER 12
#define KEYCODE_DPAD_LEFT 13
#define KEYCODE_DPAD_UP 14
#define KEYCODE_DPAD_DOWN 15
#define KEYCODE_DPAD_RIGHT 16

// CONTROLLER
#define KEYCODE_BUTTON_1 17
#define KEYCODE_BUTTON_2 18
#define KEYCODE_BUTTON_3 19
#define KEYCODE_BUTTON_4 20
#define KEYCODE_BUTTON_5 21
#define KEYCODE_BUTTON_6 22
#define KEYCODE_BUTTON_7 23
#define KEYCODE_BUTTON_8 24
#define KEYCODE_BUTTON_9 25
#define KEYCODE_BUTTON_10 26
#define KEYCODE_BUTTON_11 27
#define KEYCODE_BUTTON_12 28
#define KEYCODE_BUTTON_13 29
#define KEYCODE_BUTTON_14 30
#define KEYCODE_BUTTON_15 31
#define KEYCODE_BUTTON_16 32
#define KEYCODE_BUTTON_A 33
#define KEYCODE_BUTTON_B 34
#define KEYCODE_BUTTON_C 35
#define KEYCODE_BUTTON_X 36
#define KEYCODE_BUTTON_Y 37
#define KEYCODE_BUTTON_Z 38
#define KEYCODE_BUTTON_R1 39
#define KEYCODE_BUTTON_R2 40
#define KEYCODE_BUTTON_L1 41
#define KEYCODE_BUTTON_L2 42
#define KEYCODE_BUTTON_THUMBL 43
#define KEYCODE_BUTTON_THUMBR 44
#define KEYCODE_BUTTON_SELECT 45
#define KEYCODE_BUTTON_START 46

// NUMPAD
#define KEYCODE_NUMPAD_0 47
#define KEYCODE_NUMPAD_1 48
#define KEYCODE_NUMPAD_2 49
#define KEYCODE_NUMPAD_3 50
#define KEYCODE_NUMPAD_4 51
#define KEYCODE_NUMPAD_5 52
#define KEYCODE_NUMPAD_6 53
#define KEYCODE_NUMPAD_7 54
#define KEYCODE_NUMPAD_8 55
#define KEYCODE_NUMPAD_9 56
#define KEYCODE_NUMPAD_ADD 57
#define KEYCODE_NUMPAD_DIVIDE 58
#define KEYCODE_NUMPAD_ENTER 59
#define KEYCODE_NUMPAD_LEFT_PAREN 60
#define KEYCODE_NUMPAD_RIGHT_PAREN 61
#define KEYCODE_NUMPAD_COMMA 62
#define KEYCODE_NUMPAD_DOT 63
#define KEYCODE_NUMPAD_EQUALS 64
#define KEYCODE_NUMPAD_MULTIPLY 65
#define KEYCODE_NUMPAD_SUBTRACT 66
#define KEYCODE_NUMPAD_LOCK 67
#define KEYCODE_NUM 68

// LETTERS
#define KEYCODE_A 69
#define KEYCODE_B 70
#define KEYCODE_C 71
#define KEYCODE_D 72
#define KEYCODE_E 73
#define KEYCODE_F 74
#define KEYCODE_G 75
#define KEYCODE_H 76
#define KEYCODE_I 77
#define KEYCODE_J 78
#define KEYCODE_K 79
#define KEYCODE_L 80
#define KEYCODE_M 81
#define KEYCODE_N 82
#define KEYCODE_O 83
#define KEYCODE_P 84
#define KEYCODE_Q 85
#define KEYCODE_R 86
#define KEYCODE_S 87
#define KEYCODE_T 88
#define KEYCODE_U 89
#define KEYCODE_V 90
#define KEYCODE_W 91
#define KEYCODE_X 92
#define KEYCODE_Y 93
#define KEYCODE_Z 94

// SYMBOLS
#define KEYCODE_APOSTROPHE 95
#define KEYCODE_BACKSLASH 96
#define KEYCODE_DEL 97
#define KEYCODE_ESCAPE 98
#define KEYCODE_LEFT_BRACKET 99
#define KEYCODE_PLUS 100
#define KEYCODE_RIGHT_BRACKET 101
#define KEYCODE_SLASH 102
#define KEYCODE_STAR 103
#define KEYCODE_AT 104
#define KEYCODE_COMMA 105
#define KEYCODE_EQUALS 106
#define KEYCODE_FORWARD_DEL 107
#define KEYCODE_PERIOD 108
#define KEYCODE_POUND 109
#define KEYCODE_SEMICOLON 110
#define KEYCODE_SPACE 111
#define KEYCODE_TAB 112

// OTHER
#define KEYCODE_ALT_LEFT 113
#define KEYCODE_ALT_RIGHT 114
#define KEYCODE_BREAK 115
#define KEYCODE_CLEAR 116
#define KEYCODE_CTRL_LEFT 117
#define KEYCODE_CTRL_RIGHT 118
#define KEYCODE_ENTER 119
#define KEYCODE_FORVARD 120
#define KEYCODE_PAGE_DOWN 121
#define KEYCODE_PAGE_UP 122
#define KEYCODE_SHIFT_LEFT 123
#define KEYCODE_SHIFT_RIGHT 124
#define KEYCODE_SOFT_LEFT 125
#define KEYCODE_SOFT_RIGHT 126

// SYSTEM
#define KEYCODE_3D_MODE 127
#define KEYCODE_AVR_INPUT 128
#define KEYCODE_BACK 129
#define KEYCODE_CALCULATOR 130
#define KEYCODE_CALL 131
#define KEYCODE_CAPS_LOCK 132
#define KEYCODE_CHANNEL_DOWN 133
#define KEYCODE_CONTACTS 134
#define KEYCODE_ENDCALL 135
#define KEYCODE_EXPLORER 136
#define KEYCODE_F10 137
#define KEYCODE_F12 138
#define KEYCODE_F3 139
#define KEYCODE_F5 140
#define KEYCODE_F7 141
#define KEYCODE_F9 142
#define KEYCODE_FUNCTION 143
#define KEYCODE_GUIDE 144
#define KEYCODE_HOME 145
#define KEYCODE_INSERT 146
#define KEYCODE_MANNER_MODE 147
#define KEYCODE_MEDIA_EJECT 148
#define KEYCODE_MEDIA_NEXT 149
#define KEYCODE_MEDIA_PLAY_PAUSE 150
#define KEYCODE_MEDIA_PREVIOUS 151
#define KEYCODE_MEDIA_REWIND 152
#define KEYCODE_MENU 153
#define KEYCODE_META_RIGHT 154
#define KEYCODE_MOVE_END 155
#define KEYCODE_MUSIC 156
#define KEYCODE_NOTIFICATION 157
#define KEYCODE_POWER 158
#define KEYCODE_PROG_GREEN 159
#define KEYCODE_PROG_YELLOW 160
#define KEYCODE_SEARCH 161
#define KEYCODE_STB_INPUT 162
#define KEYCODE_SWITCH_CHARSET 163
#define KEYCODE_SYSRQ 164
#define KEYCODE_TV_POWER 165
//#define KEYCODE_UNKNOWN  166
#define KEYCODE_VOLUME_MUTE 167
#define KEYCODE_WINDOW 168
#define KEYCODE_ZOOM_OUT 169
#define KEYCODE_APP_SWITCH 170
#define KEYCODE_AVR_POWER 171
#define KEYCODE_BOOKMARK 172
#define KEYCODE_CALENDAR 173
#define KEYCODE_CAMERA 174
#define KEYCODE_CAPTIONS 175
#define KEYCODE_CHANNEL_UP 176
#define KEYCODE_DVR 177
#define KEYCODE_ENVELOPE 178
#define KEYCODE_F1 179
#define KEYCODE_F11 180
#define KEYCODE_F2 181
#define KEYCODE_F4 182
#define KEYCODE_F6 183
#define KEYCODE_F8 184
#define KEYCODE_FOCUS 185
#define KEYCODE_GRAVE 186
#define KEYCODE_HEADSETHOOK 187
#define KEYCODE_INFO 188
#define KEYCODE_LANGUAGE_SWITCH 189
#define KEYCODE_MEDIA_CLOSE 190
#define KEYCODE_MEDIA_FAST_FORWARD 191
#define KEYCODE_MEDIA_PAUSE 192
#define KEYCODE_MEDIA_PLAY 193
#define KEYCODE_MEDIA_RECORD 194
#define KEYCODE_MEDIA_STOP 195
#define KEYCODE_META_LEFT 196
#define KEYCODE_MINUS 197
#define KEYCODE_MOVE_HOME 198
#define KEYCODE_MUTE 199
#define KEYCODE_PICTSYMBOLS 200
#define KEYCODE_PROG_BLUE 201
#define KEYCODE_PROG_RED 202
#define KEYCODE_SCROLL_LOCK 203
#define KEYCODE_SETTINGS 204
#define KEYCODE_STB_POWER 205
#define KEYCODE_SYM 206
#define KEYCODE_TV_INPUT 207
#define KEYCODE_TV 208
#define KEYCODE_VOLUME_DOWN 209
#define KEYCODE_VOLUME_UP 210
#define KEYCODE_ZOOM_IN 211

//----------------------------------------------

class btca2a {
public:
  btca2a();
  void SetupHardwareSerial(unsigned char Number, long speed);
  void ReadCommand();
  boolean Button(unsigned char);
  boolean ButtonPressed(unsigned char);
  boolean ButtonReleased(unsigned char);

private:
  void SerialChoise();
  boolean buttonState[215];
  unsigned char BTdata[3];
  unsigned int keycode;
  unsigned char commandID;
  unsigned char BTvalue;
  unsigned char i;
  unsigned char PortNum;

};

#endif